'******************************************************************************'

' POLIZEI- Sirene - "Der Sparrow tnt und blinkt"--------------

'******************************************************************************'
' Taster2 / S2 an PB2 ( PCINT0) lst einen Pin- Change- Interrupt aus.
' Der P wacht auf. Der Alarm (Ton) beginnt und LED1 /LED2 blinken abwechselnd.
' Nach 6 Durchlufen fllt der P in den Powerdown- Mode .
' (Stromaufnahme bei 3V nur 1A)!
' Aus diesem Zustand kann ihn nur ein Interrupt PCINT0 wecken
' An PB0 kann OPTIONAL eine PIEZO- Buzzer angeschlossen werden.
' Ein Ausschalter ist nicht erforderlich!
'******************************************************************************'
$regfile = "ATtiny13.dat"                                   'P - Typ
$crystal = 1200000                                          'Taktfrequenz
$hwstack = 16
$swstack = 8
$framesize = 8

Config Portb.1 = Output                                     'Led1
Config Portb.3 = Output                                     'Led2
Config Portb.0 = Output                                     'Piezo
Config Portb.2 = Input                                      'Taste S2
Config Portb.4 = Output                                     'festes Potential
Stop Adc                                                    'Stop AD- Wandler
Stop Ac                                                     'Stop Analog.Komp.
Stop Watchdog


Dim H As Byte                                               ' Zhlvariable
'Timer fr Tonerzeugung konfiguriert.
Config Timer0 = Timer , Compare A = Toggle , Prescale = 8 , Clear Timer = 1
'Pin- Change - Interrupt aktivieren

        On Pcint0 Pcint0_isr
        Enable Pcint0                                       'enable PCINT2
        Pcmsk.2 = 1                                         'Taster an PB2


Main:
        Enable Interrupts                                   'Interrupt freigeben

        Do
              Powerdown                                     'Stromsparen
        Loop


        Pcint0_isr:                                         'Interuppt- Routine


For H = 0 To 5

                Ocr0a = 161                                 'ca 440 Hz

         Portb.1 = 1
         Waitms 50
         Portb.1 = 0
         Waitms 50
         Portb.1 = 1
         Waitms 50
         Portb.1 = 0
         Waitms 200


                 Ocr0a = 122                                'ca 585 Hz

         Portb.3 = 1
         Waitms 50
         Portb.3 = 0
         Waitms 50
         Portb.3 = 1
         Waitms 50
         Portb.3 = 0
         Waitms 200

Next H
  Return
Goto Main


End                                                         'Programmende